/* Generated automatically by the program `genextract'
from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "toplev.h"

static rtx junk ATTRIBUTE_UNUSED;
void
insn_extract (rtx insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED;

  switch (INSN_CODE (insn))
    {
    case -1:
      fatal_insn_not_found (insn);

    case 346:  /* alignaddrsi_vis */
    case 345:  /* faligndatav8qi_vis */
    case 344:  /* faligndatav4hi_vis */
    case 343:  /* faligndatav2si_vis */
    case 342:  /* faligndatadi_vis */
    case 341:  /* fmuld8ulx16_vis */
    case 339:  /* fmul8ulx16_vis */
    case 337:  /* fmul8x16al_vis */
    case 334:  /* fpmerge_vis */
    case 332:  /* fpack32_vis */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 316:  /* *tldo_stw_sp32 */
    case 315:  /* *tldo_sth_sp32 */
    case 314:  /* *tldo_stb_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 0), 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 0), 0), 0), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (pat, 0), 0), 0), 0, 1));
      break;

    case 312:  /* *tldo_ldsh1_sp32 */
    case 311:  /* *tldo_lduh1_sp32 */
    case 309:  /* *tldo_ldsb2_sp32 */
    case 308:  /* *tldo_ldsb1_sp32 */
    case 307:  /* *tldo_ldub2_sp32 */
    case 306:  /* *tldo_ldub1_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0, 1));
      break;

    case 313:  /* *tldo_lduw_sp32 */
    case 310:  /* *tldo_lduh_sp32 */
    case 305:  /* *tldo_ldub_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0, 1));
      break;

    case 347:  /* pdist_vis */
    case 302:  /* tie_ld32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 296:  /* tldm_call32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 292:  /* tgd_call32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 285:  /* prefetch_32 */
    case 284:  /* prefetch_64 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 2));
      break;

    case 283:  /* ffssi2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 282:  /* flushdi */
    case 281:  /* flush */
    case 279:  /* goto_handler_and_restore */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      break;

    case 277:  /* *branch_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 275:  /* update_return */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (pat, 0, 1));
      break;

    case 286:  /* trap */
    case 280:  /* do_builtin_setjmp_setup */
    case 278:  /* flush_register_windows */
    case 276:  /* nop */
    case 274:  /* blockage */
    case 273:  /* *return_internal */
      break;

    case 272:  /* save_register_windowsi */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      break;

    case 267:  /* *call_symbolic_untyped_struct_value_sp32 */
    case 266:  /* *call_address_untyped_struct_value_sp32 */
    case 265:  /* *call_symbolic_struct_value_sp32 */
    case 264:  /* *call_address_struct_value_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (pat, 0, 1));
      break;

    case 270:  /* *sibcall_symbolic_sp32 */
    case 263:  /* *call_symbolic_sp32 */
    case 262:  /* *call_address_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 261:  /* *tablejump_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 223:  /* *cmp_cc_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 209:  /* *cmp_cc_arith_op_not_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 208:  /* *cmp_cc_arith_op_not */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 207:  /* *cmp_cc_xor_not_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 206:  /* *cmp_cc_xor_not */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      break;

    case 205:  /* *cmp_cc_arith_op_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 204:  /* *cmp_cc_arith_op */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 161:  /* *umacdi */
    case 160:  /* *smacdi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 159:  /* *smacsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 156:  /* *cmp_sdiv_cc_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 259:  /* lshrdi3_v8plus */
    case 257:  /* ashrdi3_v8plus */
    case 253:  /* ashldi3_v8plus */
    case 155:  /* divsi3_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 154:  /* const_umulsi3_highpart */
    case 146:  /* const_smulsi3_highpart */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      break;

    case 153:  /* *umulsi3_highpart_sp32 */
    case 145:  /* *smulsi3_highpart_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      break;

    case 152:  /* const_umulsi3_highpart_v8plus */
    case 144:  /* const_smulsi3_highpart_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 151:  /* umulsi3_highpart_v8plus */
    case 143:  /* *sparc.md:5516 */
    case 142:  /* smulsi3_highpart_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 189:  /* *or_not_v4qi */
    case 188:  /* *or_not_v2hi */
    case 187:  /* *or_not_si */
    case 186:  /* *or_not_v8qi_sp32 */
    case 185:  /* *or_not_v4hi_sp32 */
    case 184:  /* *or_not_v2si_sp32 */
    case 183:  /* *or_not_di_sp32 */
    case 175:  /* *and_not_v4qi */
    case 174:  /* *and_not_v2hi */
    case 173:  /* *and_not_si */
    case 172:  /* *and_not_v8qi_sp32 */
    case 171:  /* *and_not_v4hi_sp32 */
    case 170:  /* *and_not_v2si_sp32 */
    case 169:  /* *and_not_di_sp32 */
    case 149:  /* const_umulsidi3_sp32 */
    case 141:  /* const_mulsidi3_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 329:  /* *nand<V32mode>_vis */
    case 328:  /* *nand<V32mode>_vis */
    case 327:  /* *nand<V32mode>_vis */
    case 326:  /* *nand<V64mode>_vis */
    case 325:  /* *nand<V64mode>_vis */
    case 324:  /* *nand<V64mode>_vis */
    case 323:  /* *nand<V64mode>_vis */
    case 234:  /* *multf3_extend */
    case 233:  /* *muldf3_extend */
    case 148:  /* *umulsidi3_sp32 */
    case 140:  /* *mulsidi3_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 150:  /* const_umulsidi3_v8plus */
    case 139:  /* const_mulsidi3_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 147:  /* umulsidi3_v8plus */
    case 138:  /* mulsidi3_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 136:  /* muldi3_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 131:  /* *sparc.md:5197 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      break;

    case 158:  /* *cmp_udiv_cc_set */
    case 137:  /* *cmp_mul_set */
    case 134:  /* cmp_minus_cc_set */
    case 129:  /* *cmp_cc_plus_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 133:  /* *cmp_minus_cc */
    case 128:  /* *cmp_cc_plus */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 125:  /* *subx_extend */
    case 123:  /* *addx_extend_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      break;

    case 130:  /* *subdi3_sp32 */
    case 121:  /* adddi3_insn_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 119:  /* fix_truncdfdi2 */
    case 118:  /* fix_truncsfdi2 */
    case 116:  /* fix_truncdfsi2 */
    case 115:  /* fix_truncsfsi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 102:  /* *cmp_zero_extract */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 96:  /* *cmp_zero_extendqisi2_andcc_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 255:  /* *cmp_cc_set_ashift_1 */
    case 222:  /* *cmp_cc_set_not */
    case 213:  /* *cmp_cc_set_neg */
    case 98:  /* *cmp_siqi_trunc_set */
    case 95:  /* *cmp_zero_extendqisi2_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 260:  /* jump */
    case 94:  /* *cmp_zero_qi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 254:  /* *cmp_cc_ashift_1 */
    case 221:  /* *cmp_cc_not */
    case 212:  /* *cmp_cc_neg */
    case 97:  /* *cmp_siqi_trunc */
    case 93:  /* *cmp_zero_extendqisi2 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 88:  /* *movtf_cc_sp64 */
    case 87:  /* *movtf_cc_hq_sp64 */
    case 86:  /* movdf_cc_sp64 */
    case 85:  /* *movsf_cc_sp64 */
    case 84:  /* *movsi_cc_sp64 */
    case 83:  /* *movhi_cc_sp64 */
    case 82:  /* *movqi_cc_sp64 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 333:  /* fexpand_vis */
    case 331:  /* fpackfix_vis */
    case 330:  /* fpack16_vis */
    case 59:  /* embmedany_brsum */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 299:  /* tldo_add32 */
    case 291:  /* tgd_add32 */
    case 44:  /* *movsi_lo_sum_pic_label_ref */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 1));
      break;

    case 43:  /* *movsi_high_pic_label_ref */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 1));
      break;

    case 303:  /* tle_hix22_sp32 */
    case 300:  /* tie_hi22 */
    case 297:  /* tldo_hix22 */
    case 289:  /* tgd_hi22 */
    case 61:  /* embmedany_texthi */
    case 60:  /* embmedany_textuhi */
    case 57:  /* embmedany_sethi */
    case 54:  /* setlm */
    case 53:  /* sethh */
    case 50:  /* seth44 */
    case 42:  /* movsi_high_pic */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0));
      break;

    case 304:  /* tle_lox10_sp32 */
    case 301:  /* tie_lo10 */
    case 298:  /* tldo_lox10 */
    case 295:  /* tldm_add32 */
    case 290:  /* tgd_lo10 */
    case 62:  /* embmedany_textulo */
    case 55:  /* sethm */
    case 51:  /* setm44 */
    case 41:  /* movsi_lo_sum_pic */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      break;

    case 288:  /* *sparc.md:8308 */
    case 287:  /* *sparc.md:8296 */
    case 81:  /* *movtf_no_e_insn_sp32 */
    case 80:  /* *movtf_insn_vis_sp32 */
    case 79:  /* *movtf_insn_sp32 */
    case 78:  /* *movdf_insn_v9only_vis */
    case 77:  /* *movdf_insn_v9only_vis */
    case 76:  /* *movdf_insn_v9only_vis */
    case 75:  /* *movdf_insn_v9only_vis */
    case 74:  /* *movdf_insn_v9only_novis */
    case 73:  /* *movdf_no_e_insn_v9_sp32 */
    case 72:  /* *movdf_no_e_insn_sp32 */
    case 71:  /* *movdf_insn_sp32 */
    case 68:  /* *movsf_no_f_insn */
    case 67:  /* *movsf_insn_vis */
    case 66:  /* *movsf_insn_vis */
    case 65:  /* *movsf_insn_vis */
    case 64:  /* *movsf_insn_novis */
    case 46:  /* *movdi_insn_sp32 */
    case 45:  /* *movdi_insn_sp32_v9 */
    case 38:  /* *movsi_insn */
    case 36:  /* *movhi_insn */
    case 35:  /* *movqi_insn */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 34:  /* load_pcrel_symsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      break;

    case 33:  /* *inverted_fpe_branch */
    case 31:  /* *inverted_fp_branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 32:  /* *normal_fpe_branch */
    case 30:  /* *normal_fp_branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 29:  /* *inverted_branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 28:  /* *normal_branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 25:  /* *x_minus_sltu_plus_y */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      break;

    case 203:  /* *xor_not_v4qi */
    case 202:  /* *xor_not_v2hi */
    case 201:  /* *xor_not_si */
    case 200:  /* *xor_not_v8qi_sp32 */
    case 199:  /* *xor_not_v4hi_sp32 */
    case 198:  /* *xor_not_v2si_sp32 */
    case 197:  /* *xor_not_di_sp32 */
    case 124:  /* subx */
    case 122:  /* addx */
    case 24:  /* *x_minus_y_minus_sltu */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 294:  /* tldm_lo10 */
    case 251:  /* sqrtsf2 */
    case 250:  /* sqrtdf2 */
    case 249:  /* *sqrttf2_hq */
    case 248:  /* abssf2 */
    case 247:  /* *absdf2_v9 */
    case 246:  /* *absdf2_notv9 */
    case 245:  /* *abstf2_v9 */
    case 244:  /* *abstf2_hq_v9 */
    case 243:  /* *abstf2_notv9 */
    case 242:  /* negsf2 */
    case 241:  /* *negdf2_v9 */
    case 240:  /* *negdf2_notv9 */
    case 239:  /* *negtf2_v9 */
    case 238:  /* *negtf2_notv9 */
    case 220:  /* one_cmplv4qi2 */
    case 219:  /* one_cmplv2hi2 */
    case 218:  /* one_cmplsi2 */
    case 217:  /* *one_cmplv8qi2_sp32 */
    case 216:  /* *one_cmplv4hi2_sp32 */
    case 215:  /* *one_cmplv2si2_sp32 */
    case 214:  /* *one_cmpldi2_sp32 */
    case 211:  /* negsi2 */
    case 120:  /* *fix_trunctfdi2_hq */
    case 117:  /* *fix_trunctfsi2_hq */
    case 114:  /* *floatditf2_hq */
    case 113:  /* floatdidf2 */
    case 112:  /* floatdisf2 */
    case 111:  /* *floatsitf2_hq */
    case 110:  /* floatsidf2 */
    case 109:  /* floatsisf2 */
    case 108:  /* *trunctfdf2_hq */
    case 107:  /* *trunctfsf2_hq */
    case 106:  /* truncdfsf2 */
    case 105:  /* *extenddftf2_hq */
    case 104:  /* *extendsftf2_hq */
    case 103:  /* extendsfdf2 */
    case 101:  /* *sign_extendqisi2_insn */
    case 100:  /* *sign_extendqihi2_insn */
    case 99:  /* *sign_extendhisi2_insn */
    case 92:  /* *zero_extendsidi2_insn_sp32 */
    case 91:  /* *zero_extendqisi2_insn */
    case 90:  /* *zero_extendqihi2_insn */
    case 89:  /* *zero_extendhisi2_insn */
    case 70:  /* *movsf_high */
    case 48:  /* *sethi_di_medlow */
    case 47:  /* *sethi_di_medlow_embmedany_pic */
    case 40:  /* *movsi_high */
    case 27:  /* *x_minus_sgeu */
    case 23:  /* *x_minus_sltu */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 22:  /* *sltu_plus_x_plus_y */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      break;

    case 18:  /* *neg_sltu_plus_x */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 26:  /* *sgeu_plus_x */
    case 21:  /* *sltu_plus_x */
    case 17:  /* *neg_sltu_minus_x */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 293:  /* tldm_hi22 */
    case 20:  /* *neg_sgeu_insn */
    case 19:  /* *sgeu_insn */
    case 16:  /* *neg_sltu_insn */
    case 15:  /* *sltu_insn */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 14:  /* *x_minus_i_eq_0 */
    case 12:  /* *x_minus_i_ne_0 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      break;

    case 271:  /* *sibcall_value_symbolic_sp32 */
    case 269:  /* *call_value_symbolic_sp32 */
    case 268:  /* *call_value_address_sp32 */
    case 126:  /* *sparc.md:5040 */
    case 13:  /* *x_plus_i_eq_0 */
    case 11:  /* *x_plus_i_ne_0 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 10:  /* *neg_seqsi_zero */
    case 8:  /* *neg_snesi_zero */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      break;

    case 210:  /* *negdi2_sp32 */
    case 9:  /* *seqsi_zero */
    case 7:  /* *snesi_zero */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      break;

    case 340:  /* fmuld8sux16_vis */
    case 338:  /* fmul8sux16_vis */
    case 336:  /* fmul8x16au_vis */
    case 335:  /* fmul8x16_vis */
    case 322:  /* subv2hi3 */
    case 321:  /* subv4hi3 */
    case 320:  /* subv2si3 */
    case 319:  /* addv2hi3 */
    case 318:  /* addv4hi3 */
    case 317:  /* addv2si3 */
    case 258:  /* lshrsi3 */
    case 256:  /* ashrsi3 */
    case 252:  /* ashlsi3 */
    case 237:  /* divsf3 */
    case 236:  /* divdf3 */
    case 235:  /* *divtf3_hq */
    case 232:  /* mulsf3 */
    case 231:  /* muldf3 */
    case 230:  /* *multf3_hq */
    case 229:  /* subsf3 */
    case 228:  /* subdf3 */
    case 227:  /* *subtf3_hq */
    case 226:  /* addsf3 */
    case 225:  /* adddf3 */
    case 224:  /* *addtf3_hq */
    case 196:  /* xorv4qi3 */
    case 195:  /* xorv2hi3 */
    case 194:  /* xorsi3 */
    case 193:  /* *xorv8qi3_sp32 */
    case 192:  /* *xorv4hi3_sp32 */
    case 191:  /* *xorv2si3_sp32 */
    case 190:  /* *xordi3_sp32 */
    case 182:  /* iorv4qi3 */
    case 181:  /* iorv2hi3 */
    case 180:  /* iorsi3 */
    case 179:  /* *iorv8qi3_sp32 */
    case 178:  /* *iorv4hi3_sp32 */
    case 177:  /* *iorv2si3_sp32 */
    case 176:  /* *iordi3_sp32 */
    case 168:  /* andv4qi3 */
    case 167:  /* andv2hi3 */
    case 166:  /* andsi3 */
    case 165:  /* *andv8qi3_sp32 */
    case 164:  /* *andv4hi3_sp32 */
    case 163:  /* *andv2si3_sp32 */
    case 162:  /* *anddi3_sp32 */
    case 157:  /* udivsi3_sp32 */
    case 135:  /* mulsi3 */
    case 132:  /* subsi3 */
    case 127:  /* addsi3 */
    case 69:  /* *movsf_lo_sum */
    case 63:  /* embmedany_textlo */
    case 58:  /* embmedany_losum */
    case 56:  /* setlo */
    case 52:  /* setl44 */
    case 49:  /* *losum_di_medlow */
    case 39:  /* *movsi_lo_sum */
    case 37:  /* *movhi_lo_sum */
    case 6:  /* *cmptf_fp */
    case 5:  /* *cmpdf_fp */
    case 4:  /* *cmpsf_fp */
    case 3:  /* *cmptf_fpe */
    case 2:  /* *cmpdf_fpe */
    case 1:  /* *cmpsf_fpe */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 0:  /* *cmpsi_insn */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    default:
      gcc_unreachable ();
    }
}
